/*******************************************************************************
 * "none" clock driver
 *******************************************************************************
 *
   Copyright (c) 1999 by Andreas Beck
 *
   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 *******************************************************************************
 * 
 * $Log: none.c,v $
 * Revision 1.2  1999/06/27 16:01:15  marcus
 * '//' does not indicate a comment in C. Understood?
 *
 * Revision 1.1  1999/02/22 00:18:17  becka
 * Added stub clockdriver "none"
 *
 * 
 *******************************************************************************
 * 
 */

#include <kgi/maintainers.h>
#define	MAINTAINER	Andreas_Beck
#define	DRIVER_NAME	"none clock driver"
#define	DRIVER_REV	"$Revision: 1.2 $"

#include <kgi/module.h>

struct kgi_clock kgi_fixed_clock =
{
	"Generic",		/* Manufacturer		*/
	"None",			/* Model		*/
	GM_ALL,			/* Supported modes	*/
	0,			/* Special capabilities	*/
	{ 0x7FFF, 0x7FFF },	/* Maximum resolution	*/
	NULL,			/* Private data hook	*/
	CLK_TYPE_FIXED,		/* Fixed clock values	*/

	/*	The clock values. Note that they have to be in descending
	**	order and that there must be no repetitions.
	*/
	{{         0,         0,         0,         0,
	           0,         0,         0,         0,
	           0,         0,         0,         0,
	           0,         0,         0,         0
	}}
};

/*
**	KGI clock driver interface
*/

int kgim_clock_init(struct kgi_card *card, struct kgi_display *dpy)
{
	NOTICE(DRIVER_NAME " rev " DRIVER_REV );
	
	card->clock = &kgi_fixed_clock;

	return card->clock ? EOK : -E(CLOCK, UNKNOWN);
}

void kgim_clock_done(struct kgi_display *dpy)
{
	NOTICE(DRIVER_NAME " unloaded");
}

int kgim_clock_check_mode(struct kgi_display *dpy, struct kgi_mode *mode,
	 enum kgi_tm_cmd *cmd)
{
	kgi_sint i;

	switch (*cmd) {

	case CMD_PROPOSE:
		return EOK;

	case CMD_LOWER:
		return EOK;

	case CMD_RAISE:
		return EOK;

	case CMD_CHECK:
		return EOK;
	default:			/* this should not happen ... */
		INTERNAL_ERROR;
		return -E(CLOCK, UNKNOWN);
	}
}

void kgim_clock_set_mode (struct kgi_display *dpy, struct kgi_mode *mode)
{
/*	CLK_out8(dpy, clkindex[mode->clock],0); */
}

int kgim_clock_command(struct kgi_graphic *graph,kgi_uint cmd,kgi_uint iobuff)
{
	return -EINVAL;
}
